manual_captions    = new Object();
manual_directories = new Object();
manual_captions = {
	'root'			: 'Tundradraw Users Manual',
	'install_0'		: 'Installation / Configuration',
		'install_1'		: 'Installation : Windows',
		'install_2'		: 'Installation : Linux',
		'install_3'		: 'Installation : Mac OSX',
	'basics_0'		: 'Basics',
		'basics_1'		: 'Basics : Introduction to Textmode',
		'basics_2'		: 'Basics : A Brief History Lesson',
		'basics_3'		: 'Basics : ASCII Artwork',
		'basics_4'		: 'Basics : ANSI Artwork',
	'info_0'		: 'Information / Resources',
		'info_1'		: 'Info : Text Art on the Web',
		'info_2'		: 'Info : Text Art in Film',
		'info_3'		: 'Info : Telnet BBS Systems',
	'concepts_0'	: 'Concepts',
		'concepts_1'	: 'Concepts : Anatomy of Text Art',
		'concepts_2'	: 'Concepts : 4-bit Color Mode',
		'concepts_3'	: 'Concepts : 24-bit Color Mode',
		'concepts_4'	: 'Concepts : Blocks / Selections',
	'drawing_0'		: 'Drawing',
		'drawing_1'		: 'Drawing : 4 bit vs. 24 bit Mode',
		'drawing_2'		: 'Drawing : Using the Keyboard',
		'drawing_3'		: 'Drawing : Using the Mouse',
		'drawing_4'		: 'Drawing : Undo/Redo System',
		'drawing_5'		: 'Drawing: Opening Artwork',
		'drawing_6'		: 'Drawing: Saving Your Work',
	'friends_0'		: 'Friends',
		'friends_1'		: 'Friends : Joint Etiquette',
		'friends_2'		: 'Friends : Connecting to a Server',
		'friends_3'		: 'Friends : Starting your own Server',
		'friends_4'		: 'Friends : Chatting with Others',
		'friends_5'		: 'Friends : Network vs. Solo',
	'ui_0'			: 'User Interface',
		'ui_1'			: 'User Interface : Menu Bar',
		'ui_2'			: 'User Interface : Color Palette',
		'ui_3'			: 'User Interface : Characters Palette',
		'ui_4'			: 'User Interface : Color Picker',
		'ui_5'			: 'User Interface : Preview Window',
		'ui_6'			: 'User Interface : Chat Window',
		'ui_7'			: 'User Interface : Userlist Window',
	'tips_0'		: 'Tips and Tricks',
		'tips_1'		: 'Tips and Tricks : Outline then Shade',
		'tips_2'		: 'Tips and Tricks : Black is a color too!',
		'tips_3'		: 'Tips and Tricks : Proportion is Everything',
		'tips_41'		: 'Tips and Tricks : Less is More',
	'beyond_0'		: 'Beyond Textmode',
		'beyond_1'		: 'Beyond Textmode : Exporting as an Image',
		'beyond_2'		: 'Beyond Textmode : Using 3rd Party Tools',
	'glossary_0'	: 'Glossary of Terms',
		'glossary_1'		: 'Glossary : Technical',
		'glossary_2'		: 'Glossary : Scene',
	'development_0'	: 'Development',
		'development_1'	: 'Development : Tundradraw Homepage',
		'development_2'	: 'Development : Dontate to Tundradraw',
		'development_3'	: 'Development : Reporting Bugs',
		'development_4'	: 'Development : Software License',
		'development_5'	: 'Development : Credits'
};
manual_directories = {
	'install'		: 'install',
	'basics'		: 'basics',
	'info'			: 'info',
	'concepts'		: 'concepts',
	'drawing'		: 'drawing',
	'friends'		: 'friends',
	'ui'			: 'ui',
	'tips'			: 'tips',
	'beyond'		: 'beyond',
	'glossary'		: 'glossary',
	'development'	: 'development'
};

// Document handler for mouseup event to remove annoying dotted focus rectangle
document.onmouseup = killFocus;



/**
 * @desc	Removes annoying dotted focus rectangle on clicked links
 * @return	void
 */
function killFocus() {
	if (document.all) {
		var srcElement = event.srcElement;
		switch (srcElement.tagName) {
			case "A" : document.body.focus(); break;
			case "IMG" : document.body.focus(); break;
			case "MAP" : document.body.focus(); break;
		}
	}
} //killFocus



/**
 * @desc	ea(Expand/Collapse All) - Expands or collapses all nodes in the TOC tree
 * @return	void
 */
function ea()
{
	nodes = Array(
		'install', /* 'basics', 'info',*/ 'concepts', 'drawing', 
		'friends', /*'ui', 'tips', 'beyond', 'glossary',*/ 'development'
	);
	if (document.getElementById('ecElement').innerHTML == '(Expand All)')
	{
		for (i=0; i<nodes.length; i++)
		{
			document.getElementById('nodes_' + nodes[i]).style.display = 'block';
		}
		document.getElementById('ecElement').innerHTML = '(Collapse All)';
	}
	else if (document.getElementById('ecElement').innerHTML == '(Collapse All)')
	{
		for (i=0; i<nodes.length; i++)
		{
			document.getElementById('nodes_' + nodes[i]).style.display = 'none';
		}
		document.getElementById('ecElement').innerHTML = '(Expand All)';
	}
} //ea



/**
 * @desc	ud(Update) - Updates user manual interface on click
 * @param	string	text	Text to populate captionElement with
 * @param	element	lid		Link ID reference for hyperlink
 * @param	string	node	Name of the node to update (show/hide)
 * @return	void
 */
function ud() {
	var argv = ud.arguments;
  	var argc = argv.length;	
	(argv[0] != '') ? text = argv[0] : '';
	(argv[1] != '') ? lid  = argv[1] : '';
	if (text)
	{
		parent.frames['topFrame'].document.getElementById('captionElement').innerHTML = text;
	}
	if (lid)
	{
		allLinks = parent.frames['leftFrame'].document.links;
		for (i=0; i<document.links.length; i++)
		{
			parent.frames['leftFrame'].document.getElementById(allLinks[i].id).className = 'idle';
		}
		parent.frames['leftFrame'].document.getElementById(lid.id).className = 'current';
	}	
} //ud



/**
 * @desc	Shows/hides child nodes
 * @param	string	node	Node parent
 * @return	void
 */
function sh(node,par)
{
	if (node)
	{
		state = parent.frames['leftFrame'].document.getElementById(node).style.display;
		if (par)
		{
			cls = parent.frames['leftFrame'].document.getElementById(par.id).className;
			if (state == 'block' && cls == 'current')
			{
				parent.frames['leftFrame'].document.getElementById(node).style.display = 'none';
			}
			else
			{
				parent.frames['leftFrame'].document.getElementById(node).style.display = 'block';
			}
		}
	}
} //sh



/**
 * @desc	Initializes a section (synch main frame content to TOC)
 * @param	string	section			Name of section to initialize
 * @param	string	sectionCaption	Text for section caption
 * @param	string	node			Name of node to expand
 * @return	void
 */
function initSection(sectionCaption, section, node)
{
	// Walk all links and turn off currents
	allLinks = parent.frames['leftFrame'].document.links;
	for (i=0; i<allLinks.length; i++)
	{
		allLinks[i].className = 'idle';
	}
	if (section)
	{
		if (parent.frames['leftFrame'].document.getElementById(section).className != 'current')
		{
			ud(sectionCaption, parent.frames['leftFrame'].document.getElementById(section));
		}
	}
	if (sectionCaption)
	{
		ud(sectionCaption);
	}
	if (node)
	{
		sh(node);
	}
} //initSection