/***************************************************************************
 *   Copyright (C) 2003-2005 by Tom Bigwood, Ron Dicho                     *
 *   veediot@ansiscene.com, icedevil@icednet.org                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "tundraaboutdialog.h"
#include <qgrid.h>

TundraAboutDialog::TundraAboutDialog(QWidget *parent, const char *name)
        : QDialog(parent, name)
{
    box = new QVBox(this);
    image = new TundraAboutImage(box);
    QGrid* grid = new QGrid(1, box);
    text = new QLabel(grid);
    text->setText("TundraDraw v0.5 Beta 1\n(c) 2003-2006 Tom Bigwood, Ron Dicho\nArtwork (c) 2005 Rick Christy\nhttp://tundradraw.ansiscene.com\n");

    QFontInfo font_info = text->fontInfo();
    int size = font_info.pixelSize();

    text->setAlignment(Qt::AlignHCenter);
    grid->setMinimumSize(text->width()+20, size*3+16+20);
    grid->setMargin(10);
    box->setMinimumSize(image->width(), image->height()+grid->height());
    setMinimumSize(image->width(), image->height()+grid->height());
    setSizePolicy(QSizePolicy::MinimumExpanding, QSizePolicy::MinimumExpanding);

    setCaption("About TundraDraw");

}


TundraAboutDialog::~TundraAboutDialog()
{
}


