/***************************************************************************
 *   Copyright (C) 2003-2005 by Tom Bigwood, Ron Dicho                     *
 *   veediot@ansiscene.com, icedevil@icednet.org                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "tundracharactercommand.h"

TundraCharacterCommand::TundraCharacterCommand(TundraModel* m, TundraDoc& doc, int x, int y) : is_remote(false)
{
    my_x = x;
    my_y = y;

    model = m;

    TundraDoc* loc = model->getItem(my_x, my_y);

    old_doc.bg_color = loc->bg_color;
    old_doc.fg_color = loc->fg_color;
    old_doc.character = loc->character;

    new_doc.bg_color = doc.bg_color;
    new_doc.fg_color = doc.fg_color;
    new_doc.character = doc.character;

    is_backspace = false;

}

TundraCharacterCommand::~TundraCharacterCommand(void)
{
}

void TundraCharacterCommand::execute() {

    TundraDoc* loc = model->getItem(my_x, my_y);

    loc->fg_color = new_doc.fg_color;
    loc->bg_color = new_doc.bg_color;

    loc->character = new_doc.character;

    if(!is_remote) {
        // Don't move the cursor if its a remote command
        if(is_backspace)
            model->setCurrentPosition(my_x, my_y);
        else
            model->setCurrentPosition(my_x+1, my_y);
    }

    model->setModified();
}

void TundraCharacterCommand::unexecute() {

    TundraDoc* loc = model->getItem(my_x, my_y);

    loc->fg_color = old_doc.fg_color;
    loc->bg_color = old_doc.bg_color;
    loc->character = old_doc.character;

    if(!is_remote)
        model->setCurrentPosition(my_x, my_y);
    model->setModified();
}
