/***************************************************************************
 *   Copyright (C) 2003-2005 by Tom Bigwood, Ron Dicho                     *
 *   veediot@ansiscene.com, icedevil@icednet.org                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef TUNDRACHARPREVIEW_H
#define TUNDRACHARPREVIEW_H

#include <qstring.h>
#include <qlabel.h>
#include <qgroupbox.h>

#include "tundramodel.h"
#include "tundracharpreviewwidget.h"

//! Container for the character set preview
/*!
	This QGroupBox subclass contains 10 TundraCharPreviewWidgets
	representing the current characters for each of the F-keys.
*/
class TundraCharPreview : public QGroupBox {
    Q_OBJECT
public:
	//! Constructor
	/*
		\param m A pointer to the model
	*/
    TundraCharPreview(TundraModel* m, QWidget* parent, const char* name=0);
	
	//! Destructor
    virtual ~TundraCharPreview();

	//! Standard Qt sizeHint override
    QSize sizeHint() const { return QSize(300,75); }

private:
    void createObjects();
    TundraModel* model;
    TundraCharPreviewWidget* f1;
    TundraCharPreviewWidget* f2;
    TundraCharPreviewWidget* f3;
    TundraCharPreviewWidget* f4;
    TundraCharPreviewWidget* f5;
    TundraCharPreviewWidget* f6;
    TundraCharPreviewWidget* f7;
    TundraCharPreviewWidget* f8;
    TundraCharPreviewWidget* f9;
    TundraCharPreviewWidget* f10;

};

#endif
