/***************************************************************************
 *   Copyright (C) 2003-2005 by Tom Bigwood, Ron Dicho                     *
 *   veediot@ansiscene.com, icedevil@icednet.org                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef TUNDRACHARPREVIEWWIDGET_H
#define TUNDRACHARPREVIEWWIDGET_H

#include <qwidget.h>
#include <qframe.h>
#include <qlabel.h>
#include <qstring.h>
#include <qvbox.h>

#include "tundramodel.h"
#include "tundracharpreviewwidgetframe.h"

//! Container for a character preview widget and label
/*!
	This QVBox subclass contains both a TundraCharPreviewWidgetFrame and its associated label 
	above it.
*/
class TundraCharPreviewWidget : public QVBox {
public:
	//! Constructor
	/*!
		\param m A pointer to the model
		\param fkey The F-key to render in the preview
	*/
    TundraCharPreviewWidget(TundraModel* m, int fkey, QWidget* parent, const char* name=0);

	//! Destructor
    virtual ~TundraCharPreviewWidget();

	//! Sets the text of the label
    void setText(QString str);

	//! Creates the label and TundraCharPreviewWidgetFrame
    void createObjects();
private:
    TundraModel* model;
    int this_key;
    QLabel* this_label;
    TundraCharPreviewWidgetFrame* this_frame;
};

#endif
