/***************************************************************************
 *   Copyright (C) 2003-2005 by Tom Bigwood, Ron Dicho                     *
 *   veediot@ansiscene.com, icedevil@icednet.org                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "tundracharpreviewwidgetframe.h"

TundraCharPreviewWidgetFrame::TundraCharPreviewWidgetFrame(TundraModel* m, int fkey, bool invertPixels, QWidget *parent, const char *name)
        : QHBox(parent, name), model(m), this_key(fkey)
{

    setFrameShape(QFrame::WinPanel);
    setFrameShadow(QFrame::Sunken);

    setSizePolicy(QSizePolicy(QSizePolicy::Fixed, QSizePolicy::Fixed));

    this_image = new TundraCharPreviewWidgetImage(model, this_key, invertPixels, this);
    this_image->setMinimumSize(9,16);
    QObject::connect(this, SIGNAL(renderKey(int )), this_image, SLOT(renderKey(int )));
}


TundraCharPreviewWidgetFrame::~TundraCharPreviewWidgetFrame()
{
}

void TundraCharPreviewWidgetFrame::updateKey(int new_key) {
    emit renderKey(new_key);
}

