/***************************************************************************
 *   Copyright (C) 2003-2005 by Tom Bigwood, Ron Dicho                     *
 *   veediot@ansiscene.com, icedevil@icednet.org                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef TUNDRACHARPREVIEWWIDGETFRAME_H
#define TUNDRACHARPREVIEWWIDGETFRAME_H

#include <qhbox.h>

#include "tundramodel.h"
#include "tundracharpreviewwidgetimage.h"

//! Draws a 3D border around the TundraCharPreviewWidgetImage
class TundraCharPreviewWidgetFrame : public QHBox
{
    Q_OBJECT
public:
	//! Constructor
	/*!
		\param m A pointer to the model
		\param fkey The F-key to render in the image
		\param invertPixels Whether to render as black on white or white on black
	*/
    TundraCharPreviewWidgetFrame(TundraModel* m, int fkey=0, bool invertPixels=true, QWidget *parent = 0, const char *name = 0);

	//! Destructor
    ~TundraCharPreviewWidgetFrame();

public slots:
	//! Sends a signal to render a new key
    void updateKey(int new_key);

signals:
	//! Notify that we are rendering a new key
    void  renderKey(int new_key);

private:
    TundraCharPreviewWidgetImage* this_image;
    TundraModel* model;
    int this_key;
};

#endif
