/***************************************************************************
 *   Copyright (C) 2003-2005 by Tom Bigwood, Ron Dicho                     *
 *   veediot@ansiscene.com, icedevil@icednet.org                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "tundracharpreviewwidgetimage.h"
extern unsigned char char_set[6][10];

TundraCharPreviewWidgetImage::TundraCharPreviewWidgetImage(TundraModel* m, int fkey, bool invertPixels, QWidget *parent, const char *name)
        : QWidget(parent, name), model(m), invert(invertPixels)
{
    this_key = fkey;
    setMinimumSize(QSize(WIDTH, HEIGHT));
    resize(WIDTH, HEIGHT);

    QObject::connect(model, SIGNAL(charSetChanged()), this, SLOT(repaint()));

}


TundraCharPreviewWidgetImage::~TundraCharPreviewWidgetImage()
{
}

void TundraCharPreviewWidgetImage::paintEvent(QPaintEvent*) {
    QPixmap background(WIDTH, HEIGHT);

    if(this_key >=0x130 && this_key < 0x103a) {
        QImage bgimage = (model->getCharacter(char_set[model->getCharSet()] [this_key-4144])->convertToImage());
        if(invert) {bgimage.invertPixels();}
        background.convertFromImage(bgimage);
        bitBlt(this, 0, 0, &background, 0, 0, WIDTH, HEIGHT,CopyROP,false);
    }
    else {
        QImage bgimage = (model->getCharacter(this_key)->convertToImage());
        if(invert){bgimage.invertPixels();}
        background.convertFromImage(bgimage);

        bitBlt(this, 0, 0, &background, 0, 0, WIDTH, HEIGHT,CopyROP,false);
    }

}


void TundraCharPreviewWidgetImage::renderKey(int new_key){
    this_key = new_key;
    this->repaint();
}
