/***************************************************************************
 *   Copyright (C) 2003-2005 by Tom Bigwood, Ron Dicho                     *
 *   veediot@ansiscene.com, icedevil@icednet.org                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef TUNDRACOMMANDVISITOR_H
#define TUNDRACOMMANDVISITOR_H

class TundraCharacterCommand;
class TundraDeleteCommand;
class TundraInsertCommand;
class TundraBlockCommand;
class TundraMoveCommand;

//! Command visitor interface
/*!
	Implement this interface to create a command visitor.
*/
class TundraCommandVisitor
{
public:
	//! Visit character command
    virtual void visitCharacterCommand(TundraCharacterCommand* c)=0;

	//! Visit delete command
    virtual void visitDeleteCommand(TundraDeleteCommand* c)=0;

	//! Visit insert command
    virtual void visitInsertCommand(TundraInsertCommand* c)=0;

	//! Visit block command
    virtual void visitBlockCommand(TundraBlockCommand* c)=0;

	//! Visit move command
    virtual void visitMoveCommand(TundraMoveCommand* c)=0;
};

#endif


