/***************************************************************************
 *   Copyright (C) 2003-2005 by Tom Bigwood, Ron Dicho                     *
 *   veediot@ansiscene.com, icedevil@icednet.org                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef TUNDRACONNECTDLG_H
#define TUNDRACONNECTDLG_H

#include <qvariant.h>
#include <qdialog.h>
#include <qhostaddress.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qmessagebox.h>
#include <qpushbutton.h>

//! Connect to server dialog
class TundraConnectDlg : public QDialog
{
    Q_OBJECT

public:
	//! Constructor
    TundraConnectDlg( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    
	//! Destructor
	~TundraConnectDlg();

	//! Get the IP address from the IP address edit box
	/*!
		\return A QString representing the ip address or hostname
	*/
    QString getIp() const {
        return ip_edit->text();
    }

	//! Get the port from the port edit box
	/*!
		\return An integer representing the port
	*/
    int getPort() const {
        return port_edit->text().toInt();
    }

	//! Get the nick from the nick edit box
	/*!
		\return A QSring representing the nick
	*/
    QString getNick() const {
        return nick_edit->text();
    }

    QLabel* ip_label;
    QLineEdit* ip_edit;
    QLabel* port_label;
    QLineEdit* port_edit;
    QLabel* nick_label;
    QLineEdit* nick_edit;
    QPushButton* connect_button;
    QPushButton* cancel_button;

protected:

protected slots:
    virtual void languageChange();
    void checkFields();

};

#endif // TUNDRACONNECTDLG_H
