/***************************************************************************
 *   Copyright (C) 2003-2005 by Tom Bigwood, Ron Dicho                     *
 *   veediot@ansiscene.com, icedevil@icednet.org                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "tundracurrentcolorbox.h"

TundraCurrentColorBox::TundraCurrentColorBox(unsigned char mode, TundraModel* m, QWidget *parent, const char *name)
        : QFrame(parent, name), my_mode(mode), model(m)
{
}


TundraCurrentColorBox::~TundraCurrentColorBox()
{
}

void TundraCurrentColorBox::mouseReleaseEvent(QMouseEvent*)
{
    if(model->getColorMode() == COLOR_24BIT) {
        QColor color;
        if(my_mode == FOREGROUND)
            color = QColorDialog::getColor(model->getPalette(model->getCurrentFg()));
        else
            color = QColorDialog::getColor(model->getPalette(model->getCurrentBg()));

        if(color.isValid()) {
            int packed_color = packColor(color.red(), color.green(), color.blue()); //((color.red() & 0x000000FF) << 16) | ((color.green() & 0x000000FF) << 8) | (color.blue() & 0x000000FF);

            if(my_mode == FOREGROUND)
                model->setCurrentFg(packed_color);
            else
                model->setCurrentBg(packed_color);
        }
    }
}

void TundraCurrentColorBox::mouseMoveEvent(QMouseEvent*) {
    if(model->getColorMode() == COLOR_24BIT) {
        QColor color;
        if(my_mode == FOREGROUND)
            color = model->getPalette(model->getCurrentFg());
        else
            color = model->getPalette(model->getCurrentBg());

        QDragObject* d = new QColorDrag(color, this);
        d->dragCopy();
    }
}
