/***************************************************************************
 *   Copyright (C) 2003-2005 by Tom Bigwood, Ron Dicho                     *
 *   veediot@ansiscene.com, icedevil@icednet.org                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef TUNDRACURRENTCOLORBOX_H
#define TUNDRACURRENTCOLORBOX_H

#include <qframe.h>
#include <qcolordialog.h>
#include <qdragobject.h>

#include "tundramodel.h"
#include "utils.h"

#define FOREGROUND 0
#define BACKGROUND 1

//! A color preview widget (current foreground or background)
/*!
	The current color box is used in the overlayed preview widgets to display
	either the current foreground color or the current background color
*/
class TundraCurrentColorBox : public QFrame
{
    Q_OBJECT
public:
	//! Constructor
	/*! 
		\param mode FOREGROUND or BACKGROUND, indicating which color to represent
		\param m A pointer to the model
	*/
    TundraCurrentColorBox(unsigned char mode, TundraModel* m, QWidget *parent = 0, const char *name = 0);

	//! Destructor
    ~TundraCurrentColorBox();

	//! Standard Qt mouseReleaseEvent override
	/*!
		We override mouseReleaseEvent so that we can pop up the color picker in 24-bit mode
	*/
    void mouseReleaseEvent(QMouseEvent*);

	//! Standard Qt mouseMoveEvent override
	/*!
		We override mouseMoveEvent so we can create a dragEvent in 24-bit mode
	*/
    void mouseMoveEvent(QMouseEvent*);
private:
    unsigned char my_mode;
    TundraModel* model;
};

#endif
