/***************************************************************************
 *   Copyright (C) 2003-2005 by Tom Bigwood, Ron Dicho                     *
 *   veediot@ansiscene.com, icedevil@icednet.org                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "tundradeletecommand.h"

TundraDeleteCommand::TundraDeleteCommand(TundraModel* m, int x, int y) : is_remote(false)
{
    model = m;
    my_x = x;
    my_y = y;

    TundraDoc* loc = model->getItem(x, y);

    old_doc.character = loc->character;
    old_doc.bg_color = loc->bg_color;
    old_doc.fg_color = loc->fg_color;
}

TundraDeleteCommand::~TundraDeleteCommand(void)
{
}

void TundraDeleteCommand::execute() {
    for(int i = my_x; i <= model->getMaxX(); i++) {
        TundraDoc* current = model->getItem(i, my_y);
        // Move everything back one
        if(i+1 <= model->getMaxX()) {
            TundraDoc* next = model->getItem(i+1, my_y);

            current->character = next->character;
            current->bg_color = next->bg_color;
            current->fg_color = next->fg_color;
        }
        else {
            current->character = 0;
            current->bg_color = 0;
            current->fg_color = 0;
        }
    }
    model->setModified();
}

void TundraDeleteCommand::unexecute() {
    for(int i = model->getMaxX(); i > my_x; --i) {
        TundraDoc* current = model->getItem(i, my_y);
        // Move everything back one
        TundraDoc* last = model->getItem(i-1, my_y);

        current->character = last->character;
        current->bg_color = last->bg_color;
        current->fg_color = last->fg_color;
    }

    TundraDoc* loc = model->getItem(my_x, my_y);
    loc->character = old_doc.character;
    loc->bg_color = old_doc.bg_color;
    loc->fg_color = old_doc.fg_color;

    model->setModified();

}
