/***************************************************************************
 *   Copyright (C) 2003-2005 by Tom Bigwood, Ron Dicho                     *
 *   veediot@ansiscene.com, icedevil@icednet.org                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef TUNDRADELETECOMMAND_H
#define TUNDRADELETECOMMAND_H

#include "tundracommand.h"
#include "tundramodel.h"
#include "tundracommandvisitor.h"

//! Remove a character from the canvas
class TundraDeleteCommand :
            public TundraCommand
{
public:
	//! Constructor
	/*!
		\param m A pointer to the model
		\param x The x location of the character to delete
		\param y The y location of the character to delete
	*/
    TundraDeleteCommand(TundraModel* m, int x, int y);

	//! Destructor
    ~TundraDeleteCommand(void);

	//! Execute the command
    void execute();

	//! Undo the command
    void unexecute();

	//! Accept a visitor
	/*!
		\param v A pointer to the command visitor
	*/
    void accept(TundraCommandVisitor* v) { v->visitDeleteCommand(this); }

	//! Mark this as a command that came in over the network
    void setRemote() { is_remote = true; }

	//! The x location of the character to delete
    int my_x;

	//! The y location of the character to delete
    int my_y;
private:
    TundraDoc old_doc;
    TundraModel* model;
    bool is_remote;
};

#endif
