/***************************************************************************
 *   Copyright (C) 2003-2005 by Tom Bigwood, Ron Dicho                     *
 *   veediot@ansiscene.com, icedevil@icednet.org                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef TUNDRAERASESTRATEGY_H
#define TUNDRAERASESTRATEGY_H

#include "tundrablockstrategy.h"
#include "tundrablockstrategyvisitor.h"

//! Erase a block of characters
class TundraEraseStrategy :
            public TundraBlockStrategy
{
public:
	//! Constructor
    TundraEraseStrategy(void);

	//! Destructor
    virtual ~TundraEraseStrategy(void);

	//! Erase the block
	/*!
		\param m A pointer to the model
		\param tl A QPoint representing the top left corner of the block
		\param br A QPoint representing the bottom right corner of the block
	*/
    void execute(TundraModel* m, QPoint& tl, QPoint& br);

	//! Accept a visitor
	/*!
		\param v A pointer to the visitor
	*/
    void accept(TundraBlockStrategyVisitor* v) { v->visitEraseStrategy(this); }
};

#endif
