/***************************************************************************
 *   Copyright (C) 2003-2005 by Tom Bigwood, Ron Dicho                     *
 *   veediot@ansiscene.com, icedevil@icednet.org                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef TUNDRAFILLBOTHSTRATEGY_H
#define TUNDRAFILLBOTHSTRATEGY_H

#include "tundrafillstrategytemplate.h"
#include "tundrablockstrategyvisitor.h"

//! Fill the selection with both a character and attribute
class TundraFillBothStrategy :
            public TundraFillStrategyTemplate
{
public:
	//! Constructor
	/*!
		\param c The character to use for the fill
		\param fgc The foreground color to use for the fill
		\param bgc The background color to use for the fill
	*/
    TundraFillBothStrategy(int c, int fgc, int bgc);
	
	//! Destructor
    virtual ~TundraFillBothStrategy(void);

	//! Fill a block from the selection with the character and attribute
	/*!
		\param loc A pointer to a block in the selection
	*/
    void fill(TundraDoc* loc);

	//! Accept a visitor
	/*!
		\param v A pointer to a block strategy visitor
	*/
    void accept(TundraBlockStrategyVisitor* v) { v->visitFillBothStrategy(this); }

	//! The character to use for the fill
    int character;

	//! The foreground color to use for the fill
    int fg_color;

	//! The background color to use for the fill
    int bg_color;
};

#endif
