/***************************************************************************
 *   Copyright (C) 2003-2005 by Tom Bigwood, Ron Dicho                     *
 *   veediot@ansiscene.com, icedevil@icednet.org                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef TUNDRAFILLFGSTRATEGY_H
#define TUNDRAFILLFGSTRATEGY_H

#include "tundrafillstrategytemplate.h"
#include "tundrablockstrategyvisitor.h"

//! Fill the selection with a specified foreground color
class TundraFillFgStrategy :
            public TundraFillStrategyTemplate
{
public:
	//! Constructor
	/*!
		\param fgc The foreground color to use for the fill
	*/
    TundraFillFgStrategy(int fgc);

	//! Destructor
    virtual ~TundraFillFgStrategy(void);

	//! Fill a single block from the selection with the foreground color
	/*!
		\param loc A pointer to a block in the selection
	*/
    void fill(TundraDoc* loc);

	//! Accept a visitor
	/*!
		\param v A pointer to a block strategy visitor
	*/
    void accept(TundraBlockStrategyVisitor* v) { v->visitFillFgStrategy(this); }

	//! The foreground color to use for the fill
    int fg_color;
};

#endif
