/***************************************************************************
 *   Copyright (C) 2003-2005 by Tom Bigwood, Ron Dicho                     *
 *   veediot@ansiscene.com, icedevil@icednet.org                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef TUNDRAFILLSTRATEGYTEMPLATE_H
#define TUNDRAFILLSTRATEGYTEMPLATE_H

#include "tundrablockstrategy.h"

//! Abstract fill strategy template
/*!
	Each of the fill strategies implements this abstract class, which provides a hook - fill() -
	that is called repeatedly for each block in the selection.
*/
class TundraFillStrategyTemplate : public TundraBlockStrategy
{
public:
	//! Constructor
    TundraFillStrategyTemplate(void);

	//! Destructor
    virtual ~TundraFillStrategyTemplate(void);

	//! Execute the fill
	/*!
		\param m A pointer to the model
		\param tl A QPoint representing the top left corner of the selection
		\param br A QPoint representing the bottom right corner of the selection
	*/
    void execute(TundraModel* m, QPoint& tl, QPoint& br);

	//! Execute the fill for a single block in the selection
	/*!
		\param loc A pointer to a single block in the selection
	*/
    virtual void fill(TundraDoc* loc)=0;
};

#endif
