/***************************************************************************
 *   Copyright (C) 2003-2005 by Tom Bigwood, Ron Dicho                     *
 *   veediot@ansiscene.com, icedevil@icednet.org                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "tundraflipxstrategy.h"

TundraFlipXStrategy::TundraFlipXStrategy()
{
}

TundraFlipXStrategy::~TundraFlipXStrategy(void)
{
}

void TundraFlipXStrategy::execute(TundraModel* m, QPoint& tl, QPoint& br) {
    int width = br.x() - tl.x();
    int height = br.y() - tl.y();

    QMap<unsigned char, unsigned char>* flip_map = m->getFlipXMap();

    for(int i = 0; i < height; i++) {
        for(int j = 0; j < (width/2); j++) {
            if(tl.x()+j >= 0 && tl.x()+j < NUM_COLS && tl.y()+j >= 0 && tl.y()+j < NUM_ROWS) {
                TundraDoc* loc = m->getItem(tl.x()+j, tl.y()+i);
                unsigned char temp_character = loc->character;
                int temp_fg_color = loc->fg_color;
                int temp_bg_color = loc->bg_color;

                TundraDoc* loc2 = m->getItem(((width-1)+tl.x())-j, tl.y()+i);
                unsigned char new_char;
                if(flip_map->contains(loc2->character))
                    new_char = (*flip_map)[loc2->character];
                else
                    new_char = loc2->character;

                loc->character = new_char;
                loc->fg_color = loc2->fg_color;
                loc->bg_color = loc2->bg_color;

                if(flip_map->contains(temp_character))
                    new_char = (*flip_map)[temp_character];
                else
                    new_char = temp_character;

                loc2->character = new_char;
                loc2->fg_color = temp_fg_color;
                loc2->bg_color = temp_bg_color;
            }
        }
    }
}
