/***************************************************************************
 *   Copyright (C) 2003-2005 by Tom Bigwood, Ron Dicho                     *
 *   veediot@ansiscene.com, icedevil@icednet.org                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef TUNDRAFLIPXSTRATEGY_H
#define TUNDRAFLIPXSTRATEGY_H

#include "tundrablockstrategy.h"
#include "tundrablockstrategyvisitor.h"

//! Flip horizontally a selection's contents
class TundraFlipXStrategy :
            public TundraBlockStrategy
{
public:
	//! Constructor
    TundraFlipXStrategy();

	//! Destructor
    virtual ~TundraFlipXStrategy(void);

	//! Accept a visitor
	/*!
		\param v A pointer to a block strategy visitor
	*/
    void accept(TundraBlockStrategyVisitor* v) { v->visitFlipXStrategy(this); }

	//! Execute the flip
	/*!
		\param m A pointer to the model
		\param tl A QPoint representing the top left corner of selection
		\param br A QPoint representing the bottom right corner of the selection
	*/
    void execute(TundraModel* m, QPoint& tl, QPoint& br);
};

#endif
