/***************************************************************************
 *   Copyright (C) 2003-2005 by Tom Bigwood, Ron Dicho                     *
 *   veediot@ansiscene.com, icedevil@icednet.org                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "tundranetblockstrategyvisitor.h"
#include "utils.h"

TundraNetBlockStrategyVisitor::TundraNetBlockStrategyVisitor() : command(0)
{
    // Save 17 characters for block command info
}


TundraNetBlockStrategyVisitor::~TundraNetBlockStrategyVisitor()
{
}

void TundraNetBlockStrategyVisitor::visitEraseStrategy(TundraEraseStrategy*) {
    command_length = 18;

    command = new char[command_length];
    command[17] = 0;
}

void TundraNetBlockStrategyVisitor::visitFillAttributeStrategy(TundraFillAttributeStrategy* s) {
    command_length = 26;

    command = new char[command_length];
    command[17] = 1;
    unpackInteger(s->fg_color, command+18);
    unpackInteger(s->bg_color, command+22);
}

void TundraNetBlockStrategyVisitor::visitFillBgStrategy(TundraFillBgStrategy* s) {
    command_length = 22;

    command = new char[command_length];
    command[17] = 2;
    unpackInteger(s->bg_color, command+18);
}

void TundraNetBlockStrategyVisitor::visitFillBothStrategy(TundraFillBothStrategy* s) {
    command_length = 30;

    command = new char[command_length];
    command[17] = 3;
    unpackInteger(s->character, command+18);
    unpackInteger(s->fg_color, command+22);
    unpackInteger(s->bg_color, command+26);
}

void TundraNetBlockStrategyVisitor::visitFillFgStrategy(TundraFillFgStrategy* s) {
    command_length = 22;

    command = new char[command_length];
    command[17] = 4;
    unpackInteger(s->fg_color, command+18);
}

void TundraNetBlockStrategyVisitor::visitPasteStrategy(TundraPasteStrategy* s) {
    command_length = (s->source_width*s->source_height*9)+8+1+17;

    command = new char[command_length];
    command[17] = 5;

    unpackInteger(s->source_width, command+18);
    unpackInteger(s->source_height, command+22);

    for(int i = 0; i < s->source_height; i++) {
        for(int j = 0; j < s->source_width; j++) {
            int loc = 26+(j*9)+(i*s->source_width*9);
            command[loc] = s->source_doc[i][j].character;
            loc = 27+(j*9)+(i*s->source_width*9);
            unpackInteger(s->source_doc[i][j].fg_color, command+loc);

            loc = 31+(j*9)+(i*s->source_width*9);
            unpackInteger(s->source_doc[i][j].bg_color, command+loc);
        }
    }
}

void TundraNetBlockStrategyVisitor::visitFlipXStrategy(TundraFlipXStrategy*) {
    command_length = 18;

    command = new char[command_length];
    command[17] = 6;
}

void TundraNetBlockStrategyVisitor::visitFlipYStrategy(TundraFlipYStrategy*) {
    command_length = 18;

    command = new char[command_length];
    command[17] = 7;
}

void TundraNetBlockStrategyVisitor::visitFillCharStrategy(TundraFillCharStrategy* s) {
    command_length = 30;

    command = new char[command_length];
    command[17] = 8;
    unpackInteger(s->character, command+18);
    unpackInteger(s->fg_color, command+22);
    unpackInteger(s->bg_color, command+26);
}
