/***************************************************************************
 *   Copyright (C) 2003-2005 by Tom Bigwood, Ron Dicho                     *
 *   veediot@ansiscene.com, icedevil@icednet.org                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef TUNDRANETCOMMANDPROCESSOR_H
#define TUNDRANETCOMMANDPROCESSOR_H

#include <qmessagebox.h>

#include "tundracommandprocessor.h"
#include "utils.h"

//! Network command processor
/*!
    The network command processor is responsible for parsing commands received
    over the network.
*/
class TundraNetCommandProcessor :
            public TundraCommandProcessor
{
    Q_OBJECT
public:
    //! Constructor
    /*!
        \param m A pointer to the model
    */
    TundraNetCommandProcessor(TundraModel* m);

    //! Destructor
    ~TundraNetCommandProcessor(void);

    //! Parse a network command
    /*!
        \param data A pointer to the command data
        \param length The length of the data in the command buffer
    */
    Q_ULONG parseNetCommand(char* data, Q_ULONG length);
signals:
    //! Notify that a user has logged in
    void userLoggedIn(QString);

    //! Notify that a user has logged out
    void userLoggedOut(QString);

    //! Notify that a user has sent a message
    void userMessage(QString,QString);

};

#endif
