/***************************************************************************
 *   Copyright (C) 2003-2005 by Tom Bigwood, Ron Dicho                     *
 *   veediot@ansiscene.com, icedevil@icednet.org                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "tundrapalette.h"

TundraPalette::TundraPalette(TundraModel* m, QWidget* parent, const char* name) : QGroupBox(2, Qt::Vertical, "Palette", parent, name), model(m)
{
    TundraColorBox* cb1 = new TundraColorBox(m, BLACK, 0, true, this);
    TundraColorBox* cb2 = new TundraColorBox(m, LT_BLACK, 8, false, this);
    TundraColorBox* cb3 = new TundraColorBox(m, BLUE, 4, true, this);
    TundraColorBox* cb4 = new TundraColorBox(m, LT_BLUE, 12, false, this);
    TundraColorBox* cb5 = new TundraColorBox(m, GREEN, 2, true, this);
    TundraColorBox* cb6 = new TundraColorBox(m, LT_GREEN, 10, false, this);
    TundraColorBox* cb7 = new TundraColorBox(m, CYAN, 6, true, this);
    TundraColorBox* cb8 = new TundraColorBox(m, LT_CYAN, 14, false, this);
    TundraColorBox* cb9 = new TundraColorBox(m, RED, 1, true, this);
    TundraColorBox* cb10 = new TundraColorBox(m, LT_RED, 9, false, this);
    TundraColorBox* cb11 = new TundraColorBox(m, MAGENTA, 5, true, this);
    TundraColorBox* cb12 = new TundraColorBox(m, LT_MAGENTA, 13, false, this);
    TundraColorBox* cb13 = new TundraColorBox(m, YELLOW, 3, true, this);
    TundraColorBox* cb14 = new TundraColorBox(m, LT_YELLOW, 11, false, this);
    TundraColorBox* cb15 = new TundraColorBox(m, WHITE, 7, true, this);
    TundraColorBox* cb16 = new TundraColorBox(m, LT_WHITE, 15, false, this);

    setInsideSpacing(1);

    cb1->show();
    cb2->show();
    cb3->show();
    cb4->show();
    cb5->show();
    cb6->show();
    cb7->show();
    cb8->show();
    cb9->show();
    cb10->show();
    cb11->show();
    cb12->show();
    cb13->show();
    cb14->show();
    cb15->show();
    cb16->show();
}

TundraPalette::~TundraPalette()
{

}
