/***************************************************************************
 *   Copyright (C) 2003-2005 by Tom Bigwood, Ron Dicho                     *
 *   veediot@ansiscene.com, icedevil@icednet.org                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "tundrapastestrategy.h"

TundraPasteStrategy::TundraPasteStrategy(TundraDoc** doc, int width, int height)
{
    source_width = width;
    source_height = height;
    source_doc = doc;
}

TundraPasteStrategy::~TundraPasteStrategy(void)
{
}

void TundraPasteStrategy::execute(TundraModel* m, QPoint& tl, QPoint&) {
    for(int i = 0; i < source_height; i++) {
        for(int j = 0; j < source_width; j++) {
            if(((j+tl.x()) <= m->getMaxX()) && (j+tl.x()) >= 0 && (i+tl.y()) >= 0 && ((i+tl.y()) <= m->getMaxY())) {
                TundraDoc* current = m->getItem(j+tl.x(), i+tl.y());

                current->character = source_doc[i][j].character;
                current->bg_color = source_doc[i][j].bg_color;
                current->fg_color = source_doc[i][j].fg_color;
            }
        }
    }

}
