/***************************************************************************
 *   Copyright (C) 2003-2005 by Tom Bigwood, Ron Dicho                     *
 *   veediot@ansiscene.com, icedevil@icednet.org                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <qfile.h>
#include <qtextstream.h>

#include "tundrasaveasciistrategy.h"

TundraSaveAsciiStrategy::TundraSaveAsciiStrategy()
{
}


TundraSaveAsciiStrategy::~TundraSaveAsciiStrategy()
{
}

bool TundraSaveAsciiStrategy::saveFile(QString filename, TundraDoc** document, int max_y, QByteArray*, QPoint*, QPoint*) {
    // First find the last row
    int max_row = 0;
    for(int i = 0; i < max_y; i++) {
        for(int j = 0; j < NUM_COLS; j++) {
            if(document[i][j].character != 0) {
                max_row = i;
                break;
            }
        }
    }

    QFile output(filename);
    if(output.open(IO_WriteOnly | IO_Truncate)) {
        QTextStream os(&output);
        for(int i = 0; i <= max_y; i++) {
            int over_count = 0;
            int j;

            for(j = 0; j < NUM_COLS; j++) {

                if(document[i][j].character == 0)
                    over_count++;
                else {
                    for(int m = 0; m < over_count; m++)
                        os << " ";

                    over_count = 0;
                    os << char(document[i][j].character);

                }
            }

            os << "\n";
        }

        output.close();

        return true;
    }
    else
        return false;
}

