/***************************************************************************
 *   Copyright (C) 2003-2005 by Tom Bigwood, Ron Dicho                     *
 *   veediot@ansiscene.com, icedevil@icednet.org                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef TUNDRASAVEASCIISTRATEGY_H
#define TUNDRASAVEASCIISTRATEGY_H

#include <tundrasavestrategy.h>

//! Save an ASCII file
class TundraSaveAsciiStrategy : public TundraSaveStrategy
{
public:
    //! Constructor
    TundraSaveAsciiStrategy();

    //! Destructor
    virtual ~TundraSaveAsciiStrategy();

    //! Save the file
    /*!
        \param filename The name to use for the file
        \param document A pointer to the document
        \param max_y The last row in the drawing with a character
        \param ba A pointer to a byte array for copying to the clipboard
        \param top_left A pointer to a QPoint representing the top left corner of the block to save to clipboard
        \param bottom_right A pointer to a QPointer representing the bottom right corner of the block to save to clipboard
    */
    bool saveFile(QString filename, TundraDoc** document, int max_y, QByteArray* ba = 0, QPoint* top_left = 0, QPoint* bottom_right = 0);

};

#endif
