/***************************************************************************
 *   Copyright (C) 2003-2005 by Tom Bigwood, Ron Dicho                     *
 *   veediot@ansiscene.com, icedevil@icednet.org                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef TUNDRASERVERCONNECTION_H
#define TUNDRASERVERCONNECTION_H

#include <qsocket.h>

//! A socket connection handled by the server
class TundraServerConnection :
            public QSocket
{
public:
    //! Constructor
    TundraServerConnection(void);

    //! Destructor
    ~TundraServerConnection(void);

    //! Mark this connection as logged in
    void setLoggedIn() { logged_in = true; }

    //! Check if the user on this connection has logged in
    bool isLoggedIn() const { return logged_in; }
private:
    bool logged_in;
};

#endif
