/***************************************************************************
 *   Copyright (C) 2003-2005 by Tom Bigwood, Ron Dicho                     *
 *   veediot@ansiscene.com, icedevil@icednet.org                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef TUNDRASTARTSERVERDLG_H
#define TUNDRASTARTSERVERDLG_H

#include <qvariant.h>
#include <qdialog.h>
#include <qlineedit.h>
#include <qlabel.h>
#include <qmessagebox.h>
#include <qpushbutton.h>
#include <qvbuttongroup.h>
#include <qradiobutton.h>
#include <qcheckbox.h>

//! The start server dialog
class TundraStartServerDlg : public QDialog
{
    Q_OBJECT

public:
    //! Constructor
    TundraStartServerDlg( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    
    //! Destructor
    ~TundraStartServerDlg();

    //! Accessor function for the port edit text
    int getPort() const {
        return port_edit->text().toInt();
    }

    //! Accessor function for the nick edit text
    QString getNick() const {
        return nick_edit->text();
    }

    QLineEdit* port_edit;
    QLineEdit* nick_edit;
    QLabel* nick_label;
    QPushButton* start_button;
    QPushButton* cancel_button;
    QLabel* port_label;
    QVButtonGroup* server_opts;
    QRadioButton* server_readonly;
    QRadioButton* server_readwrite;
    QCheckBox* server_readwriteload;

    //! Get whether or not read only was checked
    bool isReadOnly() { return read_only; }

    //! Get whether or not allow load was checked
    bool isAllowLoad() {
        if(!read_only)
            return allow_load;
        else
            return false;
    }

protected:

protected slots:
    virtual void languageChange();
    void server_readonly_Checked();
    void server_readwrite_Checked();
    void server_readwriteload_Checked();
    void checkFields();

private:
    bool read_only;
    bool allow_load;

};

#endif // TUNDRASTARTSERVERDLG_H
