/***************************************************************************
 *   Copyright (C) 2003-2005 by Tom Bigwood, Ron Dicho                     *
 *   veediot@ansiscene.com, icedevil@icednet.org                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef TUNDRAUSERLIST_H
#define TUNDRAUSERLIST_H

#include <qlistbox.h>

//! The user list widget
class TundraUserList : public QListBox
{
    Q_OBJECT
public:
    //! Constructor
    TundraUserList(QWidget *parent = 0, const char *name = 0);

    //! Destructor
    ~TundraUserList();

    //! Standard Qt sizeHint override
    QSize sizeHint() const { return QSize(100,140); }
public slots:

    //! Add a user to the user list
    /*!
        \param name The name to add
    */
    void addUser(QString name);

    //! Remove a user from the user list
    /*!
        \param name The name to remove
    */
    void removeUser(QString name);
};

#endif
