/***************************************************************************
 *   Copyright (C) 2003-2005 by Tom Bigwood, Ron Dicho                     *
 *   veediot@ansiscene.com, icedevil@icednet.org                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "utils.h"

int packInteger(char* data) {
    int integer = ((data[0] << 24) & 0xFF000000) | ((data[1] << 16) & 0x00FF0000) | ((data[2] << 8) & 0x0000FF00) | (data[3] & 0x000000FF);
    return integer;
}

void unpackInteger(int integer, char* data) {
    unsigned int uinteger = (unsigned int)integer;
    data[0] = (char)((uinteger >> 24) & 0x000000FF);
    data[1] = (char)((uinteger >> 16) & 0x000000FF);
    data[2] = (char)((uinteger >> 8) & 0x000000FF);
    data[3] = (char)(uinteger & (unsigned)0x000000FF);
}


int packColor(int red, int green, int blue) {
    int packed_color = ((red & 0x000000FF) << 16) | ((green & 0x000000FF) << 8) | (blue & 0x000000FF);
    return packed_color;
}
